Attribute VB_Name = "Module1"

Public Const TO_DEGREES = 57.2957795130823
Public Const TO_RADIANS = 1.74532925199433E-02
Public Const PI = 3.14159265358979
Public Const VarOfP0X = 0.5 ^ 2
Public Const VarOfP0Y = 0.5 ^ 2
Public tau(1 To 29) As Double
Public Const FINISH = 1
Public Const CONTINUE = 0
Public Const RECALCULATE = 2

'Public Declare Function MYFUNC_ATAN2 Lib "c:\data\pascaldll.dll" (ByVal v1 As Double, ByVal v1 As Double) As Double
'Declare Function MYFUNC_MATLABCALLRESECTION Lib "c:\data\pascaldll.dll" (ByVal v1 As Double) As Double
' Declare Function MYFUNC_EIG Lib "c:\data\Eigdll.dll" (ByRef aa As Single, ByRef dd As Single, ByRef dd As Single, ByVal cols As Long, ByVal rows As Long) As Double


Public BK As Double
Public NumOfObservations As Long
Public sigmaNull As Double
Public dx As Double
Public dy As Double
Public sigmaX As Double
Public sigmaY As Double
Public Baarda() As Double
Public MaxBaardaIndex As Long

Public nobs As Long

Type Point3D
 x As Double
 y As Double
 Z As Double
End Type

Type Tree
 plotNum As Long
 id As Long
 Pos As Point3D
 Sp As Long
 status As Long
 d13 As Double
 h As Double
 hc As Double
End Type

Public Type Sighting
 plotNum As Long
 Ntree As Long
 Sp As Long
 NPA As Long
 Ndist As Long
 Nazim As Long
 TreeNum(1 To 20) As Long
 TreeSp(1 To 20) As Long
 TreePos(1 To 20) As Point3D
 Bussol(1 To 20) As Double
 Distance(1 To 20) As Double
 IsDistance(1 To 20) As Boolean
 IsBussol(1 To 20) As Boolean
End Type
Public sobs() As Sighting


Public Type PhotoTree
 plotNum As Long
 num As Long
 Pos As Point3D
 Zbutt As Double
 spec As Long
 state As Long
 d13 As Double
 foto_h As Double
 Lidar_h As Double
 Dcrm_foto As Double
 Dcrm_LiDAR As Double
 Dcrm_RMSE As Double
 a1 As Double
 a2 As Double
 a3 As Double
 Dist As Double
 Azim As Double
 InOut As Byte
End Type

Public Trees() As PhotoTree

Type ObservationRecord
 idAzim As Long
 idDist As Long
 ISdist As Boolean
 DistTree As Tree
 TrueDist As Double
 ObsDist As Double
 ISazim As Boolean
 AzimTree As Tree
 TrueAzim As Double
 ObsAzim As Double
 Slope As Double
 EpsilonDist As Double
 EpsilonAzim As Double
 ResidDist As Double
 ResidAzim As Double
End Type

Public obs() As ObservationRecord

Type UnknownPoint
 plotNum As Long
 id As Long
 Sp As Long
 status As Long
 d13 As Double
 h As Double
 hc As Double
 TruePos As Point3D
 InitialWithNoAdjustmentPos As Point3D
 InitialPos As Point3D
End Type

Public P0 As UnknownPoint

Type ControlPOint
 id As Long
 Sp As Long
 status As Long
 d13 As Double
 h As Double
 hc As Double
 TruePos As Point3D
 PhotoTruePos As Point3D
 PhotoPos As Point3D
 EpsilonXa As Double
 EpsilonYa As Double
End Type

Public PA() As ControlPOint

Type Sector
  StartAzim As Double
  EndAzim As Double
End Type

Type InputParameters
 NPA As Long                 ' Number of control points PA
 EepsXA As Double            ' Expectance of photogrammetric positioning error in XA
 EepsYA As Double            ' Expectance of photogrammetric positioning error in YA
 SDEpsXa As Double           ' SD of photogrammetric positioning error in XA
 SDEpsYa As Double           ' SD of photogrammetric positioning error in YA
 Ntheta As Long              ' Number of sectors
 Sectors(1 To 4) As Sector   ' Sectors defined by start- and endazimuth
 Ndist As Long               ' Number of distance observations
 Edist As Double             ' expectance of distance observations (mean distance to control point)
 SDdist As Double            ' SD of distance observations
 MinDist As Double           ' Minimum allowed distance
 MaxDist As Double           ' Maximum allowed distance
 Nazim As Long               ' Number of azimuth observations
 Eepsdist As Double          ' expectance of distance measurement errors
 SDepsdist As Double         '      SD                   "
 Eepsazim As Double          ' expectance of azimuth measurement errors
 SDepsazim As Double         '      SD                   "
 ISNeedOfGenerating As Boolean
 OutputFilename As String
 NumberOfSimulations As Long
End Type

Public InputParam As InputParameters

Type OutPutParameters
TypeOfInitialApproximationSolution As String * 8
End Type
Public OutputParam As OutPutParameters

Rem Matrices of LSA
Public A() As Double
Public AT() As Double ' transpose of A
Public ATP() As Double
Public ATPA() As Double
Public ATPAinv() As Double
Public ATPy() As Double
Public vTPM() As Double
Public vTPMv() As Double
Public sigmaN() As Double
Public x() As Double
Public Qxx() As Double
Public diagQxx() As Double
Public y() As Double
Public P() As Double
Public PM() As Double ' matrix version
Public PMinv() As Double ' matrix version
Public AQxx() As Double ' matrix version
Public AQxxAT() As Double ' matrix version
Public Qvv() As Double ' matrix version

Public Qxxx() As Single
Public dd() As Single
Public vv() As Single

Global Const MAX_DIM = 60
Global System_DIM As Integer 'Current Matrix [A] dimensions
Global Matrix_A(1 To MAX_DIM, 1 To MAX_DIM) As Double
Global Operations_Matrix(1 To MAX_DIM, 1 To 2 * MAX_DIM) As Double 'Matrix where the calculations are done
Global Inverse_Matrix(1 To MAX_DIM, 1 To MAX_DIM) As Double 'Matrix with the Inverse of [A]
Global Transpose_Matrix(1 To MAX_DIM, 1 To MAX_DIM)  As Double 'Matrix with the Transpose of [A]
Global Solution_Problem As Boolean 'Determines whether the inverse was found or not
Global Matrix_Mult(1 To MAX_DIM, 1 To MAX_DIM) As Double 'Matrix with the product [A]*[A-1]=[I] (must be always equal to Singular matrix [I])


Public Sub AssignTaus()
tau(1) = 55
tau(2) = 3.5163639615013
tau(3) = 2.58851466030293
tau(4) = 2.38320459203882
tau(5) = 2.29373589135547
tau(6) = 2.24316748793815
tau(7) = 2.21046085464164
tau(8) = 2.18750748837101
tau(9) = 2.17047552871447
tau(10) = 2.15731617919514
tau(11) = 2.14684407620411
tau(12) = 2.1383119392288
tau(13) = 2.1312126269278
tau(14) = 2.12521877179153
tau(15) = 2.12008514417304
tau(16) = 2.11565062799119
tau(17) = 2.11176316036548
tau(18) = 2.1083395253711
tau(19) = 2.10530008160788
tau(20) = 2.10258338291667
tau(21) = 2.10013609335436
tau(22) = 2.09792345581762
tau(23) = 2.09591270592162
tau(24) = 2.09407750489925
tau(25) = 2.09239698036049
tau(26) = 2.09085103863992
tau(27) = 2.08941987025281
tau(28) = 2.08809534661565
tau(29) = 2.08687407583499


End Sub

Public Sub Open_Input_Parameters()

Dim Ctext As String

'On Error GoTo Virhetilanne
Close (1)
Open "C:\data\SimulationInputParameters2.txt" For Input As 1
Input #1, Ctext
Input #1, InputParam.OutputFilename
Input #1, Ctext
Input #1, InputParam.NumberOfSimulations
Input #1, Ctext
Input #1, BK
Input #1, Ctext
Input #1, InputParam.EepsXA, InputParam.EepsYA
Input #1, Ctext
Input #1, InputParam.SDEpsXa, InputParam.SDEpsYa
Input #1, Ctext
Input #1, InputParam.Ntheta
Input #1, Ctext
 For i = 1 To InputParam.Ntheta
  Input #1, InputParam.Sectors(i).StartAzim, InputParam.Sectors(i).EndAzim
 Next i
Input #1, Ctext
Input #1, Dummy
Input #1, Ctext
Input #1, InputParam.Edist
Input #1, Ctext
Input #1, InputParam.SDdist
Input #1, Ctext
Input #1, InputParam.MinDist
Input #1, Ctext
Input #1, InputParam.MaxDist
Input #1, Ctext
Input #1, Dummy
Input #1, Ctext
Input #1, InputParam.Eepsdist
Input #1, Ctext
Input #1, InputParam.SDepsdist
Input #1, Ctext
Input #1, InputParam.Eepsazim
Input #1, Ctext
Input #1, InputParam.SDepsazim
Input #1, Ctext
Dim apu As Integer
Input #1, apu
InputParam.ISNeedOfGenerating = apu
Close (1)
Exit Sub
Virhetilanne:
MsgBox ("error")
Close (1)
Exit Sub
End Sub


Public Sub CreateP0()
Rem This routine creates true value for the unknown point P0
P0.TruePos.x = 0
P0.TruePos.y = 0
P0.TruePos.Z = 0
End Sub

Public Sub AssignPointsPAandTrueObservations(k As Long)

Rem k is the index of tree in need of positioning (index to sobs() -array)

ReDim obs(1 To sobs(k).NPA) As ObservationRecord
ReDim PA(1 To sobs(k).NPA) As ControlPOint

For i = 1 To sobs(k).NPA
If sobs(k).IsDistance(i) = True Then
  obs(i).TrueDist = sobs(k).Distance(i)
End If
 If sobs(k).IsBussol(i) = True Then
  obs(i).TrueAzim = sobs(k).Bussol(i)
 End If
Next i


For i = 1 To sobs(k).NPA
   PA(i).TruePos.x = sobs(k).TreePos(i).x
   PA(i).TruePos.y = sobs(k).TreePos(i).y
Next i

End Sub

Public Sub DefineObservations(k As Long)

Rem This routine selects, among the PA trees, those for which we have azimuth and distance observations, sets

For i = 1 To sobs(k).NPA
 obs(i).ISdist = sobs(k).IsDistance(i)
 obs(i).ISazim = sobs(k).IsBussol(i)
Next i

End Sub

Public Function NormDev(expectance As Double, variance As Double) As Double

Dim rsq As Double, v1 As Double, v2 As Double

rsq = 2#

Do
 v1 = 2# * Rnd - 1#
 v2 = 2# * Rnd - 1#
 rsq = v1 * v1 + v2 * v2
If (rsq < 1# And rsq > 0) Then GoTo exithere
Loop


exithere:
fac = Sqr(-2# * Log(rsq) / rsq)
If Rnd > 0.5 Then
 NormDev = v2 * fac * Sqr(variance) + expectance
Else
 NormDev = v1 * fac * Sqr(variance) + expectance
End If

End Function


Public Sub PerformPhotogrammetricObservations(k As Long)

For i = 1 To sobs(k).NPA
 PA(i).PhotoPos.x = PA(i).TruePos.x
 PA(i).PhotoPos.y = PA(i).TruePos.y
 PA(i).PhotoTruePos.x = PA(i).PhotoPos.x
 PA(i).PhotoTruePos.y = PA(i).PhotoPos.y
Next i

End Sub

Public Sub PerformFieldObservations(k As Long)
Rem This routine affects the distance and azimuth observations by additive Gaussian error terms
'Open "c:\epsilons.txt" For Append As 1

For i = 1 To sobs(k).NPA
     obs(i).ObsDist = obs(i).TrueDist
     
     If obs(i).TrueAzim < 360 - BK Then
       obs(i).TrueAzim = obs(i).TrueAzim + BK
     Else
       obs(i).TrueAzim = -(360 - obs(i).TrueAzim) + BK
     End If
     If obs(i).TrueAzim >= 90 And obs(i).TrueAzim <= 270 Then obs(i).ObsAzim = TO_RADIANS * (-(obs(i).TrueAzim - 90))
     If obs(i).TrueAzim > 0 And obs(i).TrueAzim <= 90 Then obs(i).ObsAzim = TO_RADIANS * (90 - (obs(i).TrueAzim))
     If obs(i).TrueAzim > 270 And obs(i).TrueAzim <= 360 Then obs(i).ObsAzim = (5 * PI / 2 - 2 * PI / 360 * obs(i).TrueAzim)
    obs(i).TrueAzim = obs(i).ObsAzim

Next i

End Sub
Public Sub InitialApproximation(m As Long)
Rem This routine computes initial approximation for coordinates of unknown point P0

Rem Check if there are control point with both types of observation
Rem If fails, check if there are more than 1 azimuth for line intersection
Rem If fails, use the known position + randomize and report
Dim k As Long, sumX As Double, sumY As Double
k = 0
For i = 1 To sobs(m).NPA
 If obs(i).ISazim = True And obs(i).ISdist = True Then
   k = k + 1
   P0.InitialPos.x = PA(i).PhotoPos.x - obs(i).ObsDist * Cos(obs(i).ObsAzim)
   sumX = sumX + P0.InitialPos.x
   P0.InitialPos.y = PA(i).PhotoPos.y - obs(i).ObsDist * Sin(obs(i).ObsAzim)
   sumY = sumY + P0.InitialPos.y
  End If
Next i

If k > 0 Then
 P0.InitialPos.x = sumX / CDbl(k)
 P0.InitialPos.y = sumY / CDbl(k)
 P0.InitialWithNoAdjustmentPos.x = P0.InitialPos.x
 P0.InitialWithNoAdjustmentPos.y = P0.InitialPos.y
 OutputParam.TypeOfInitialApproximationSolution = "POLAR"
 Exit Sub
End If

Rem We end up here if there are no trees with a pair-observation
Rem Check number of Azimuths
start:
k = 0
sumX = 0
sumY = 0
If sobs(m).Nazim > 1 Then
For i = 1 To sobs(m).NPA
 If obs(i).ISazim = True Then
   obs(i).Slope = Tan(obs(i).ObsAzim)
   If obs(i).ObsAzim > PI / 2 Or obs(i).ObsAzim < -PI / 2 Then
    If obs(i).ObsAzim > PI / 2 Then obs(i).Slope = Tan(obs(i).ObsAzim - PI)
    If obs(i).ObsAzim < -PI / 2 Then obs(i).Slope = Tan(obs(i).ObsAzim + PI)
   End If
 End If
Next i


For i = 1 To (sobs(m).NPA - 1)
 If obs(i).ISazim = True Then
  For j = i + 1 To sobs(m).NPA
  Rem Do not allow two parallel lines to intersect
  Azim1 = obs(i).ObsAzim
  Azim2 = obs(j).ObsAzim
  diffAzim = Azim1 - Azim2
      
   If Azim1 > PI / 2 Then
     Rem Observations is in quadrant 4
     If Azim2 >= -PI / 2 And Azim2 <= PI Then
     Rem 2nd obs is in quadrants 1,2 or 4
      diffAzim = Azim1 - Azim2
      Else
      Rem 2nd obs is in quadrant 3
      diffAzim = -(PI - Azim1) - (PI + Azim2)
     End If
    End If
    
    If Azim1 < -PI / 2 Then
    Rem Observation is in quadrant 3
     If Azim2 >= -PI And Azim2 <= PI / 2 Then
    Rem 2nd obs is in quadrants 3,2 or 1
      diffAzim = Azim1 - Azim2
     Else
    Rem 2nd obs is in quadrant 4
      diffAzim = (PI - Azim1) - (PI + Azim2)
     End If
    End If
   If obs(j).ISazim = True And (Abs(diffAzim) > 20 * TO_RADIANS) And (Abs(diffAzim) < 160 * TO_RADIANS) Then

'   If obs(j).ISazim = True And (diffAzim > 20 * TO_RADIANS) And ((diffAzim < 160 * RADIANS) Or (diffAzim > 200 * RADIANS)) Then
     k = k + 1
     P0.InitialPos.x = (obs(i).Slope * PA(i).PhotoPos.x - PA(i).PhotoPos.y - obs(j).Slope * PA(j).PhotoPos.x + PA(j).PhotoPos.y) / (obs(i).Slope - obs(j).Slope)
     sumX = sumX + P0.InitialPos.x
     P0.InitialPos.y = obs(i).Slope * (P0.InitialPos.x - PA(i).PhotoPos.x) + PA(i).PhotoPos.y
     sumY = sumY + P0.InitialPos.y
    End If
  Next j
 End If
Next i
End If
 
If k > 0 Then
 P0.InitialPos.x = sumX / CDbl(k)
 P0.InitialPos.y = sumY / CDbl(k)
 P0.InitialWithNoAdjustmentPos.x = P0.InitialPos.x
 P0.InitialWithNoAdjustmentPos.y = P0.InitialPos.y
 If Abs(P0.InitialWithNoAdjustmentPos.y) > 2 Or Abs(P0.InitialWithNoAdjustmentPos.x) > 2 Then
  'MsgBox ("Here!")
'  GoTo start
 End If
 OutputParam.TypeOfInitialApproximationSolution = "INTERSEC"
 Exit Sub
End If
 
Rem If we end up here, we must make initial approximation of P0 near its true value
 
' P0.InitialPos.x = P0.TruePos.x + NormDev(0, VarOfP0X)
' P0.InitialPos.y = P0.TruePos.y + NormDev(0, VarOfP0Y)
' P0.InitialWithNoAdjustmentPos.x = P0.InitialPos.x
' P0.InitialWithNoAdjustmentPos.y = P0.InitialPos.y
' OutputParam.TypeOfInitialApproximationSolution = "FORCED"
MsgBox ("Finding initial approximation failed")
 
End Sub

Public Sub CreateMatricesAndVectorsForLSA(ix As Long)

Rem This routine fills the design matrix A with the partial derivates
Rem delta(dist)/delta(X), delta(dist)/delta(Y), delta(azim)/delta(X), delta(azim)/delta(Y)
Rem A has Nazim+Ndist rows, and 2 columns

Rem Weight matrix P is represented by its diagonal vector as all other elements are zero
Rem Weights in P for dist observations are 1/sigmaepsdist^2
Rem Weights in P for azim observations are 1/sigmaepsazim^2

Rem Vector y has the differences between observations and linearized values

k = 0
For i = 1 To sobs(ix).NPA
  If obs(i).ISdist = True Then k = k + 1
  If obs(i).ISazim = True Then k = k + 1
Next i

Dim NofNonZeroInA As Long, df As Long

Rem Now we now the dimensions of A, P and y (rows x columns), or (rows) for vectors
ReDim A(1 To k + 2 * sobs(ix).NPA, 1 To 2 + 2 * sobs(ix).NPA) As Double
ReDim P(1 To k + 2 * sobs(ix).NPA) As Double
ReDim y(1 To k + 2 * sobs(ix).NPA) As Double
Dim X0 As Double, Y0 As Double, Xa As Double, Ya As Double, LinearizedAzim As Double
Dim LinearizedDist As Double

Open "c:\data\A_txt.txt" For Output As 11
Open "C:\data\l_txt.txt" For Output As 12
Open "c:\data\weigths.txt" For Output As 13
NumOfObservations = k + 2 * sobs(ix).NPA

Close (14)

k = 0
X0 = P0.InitialPos.x
Y0 = P0.InitialPos.y

For i = 1 To sobs(ix).NPA
  
  Xa = PA(i).PhotoPos.x
  Ya = PA(i).PhotoPos.y
' Xa = PA(i).PhotoTruePos.X
' Ya = PA(i).PhotoTruePos.y
 
  If obs(i).ISazim = True Then
    k = k + 1
    A(k, 1) = (-(-Ya + Y0) / (X0 ^ 2 - 2 * X0 * Xa + Xa ^ 2 + Y0 ^ 2 - 2 * Y0 * Ya + Ya ^ 2))
    A(k, 2) = ((-Xa + X0) / (X0 ^ 2 - 2 * X0 * Xa + Xa ^ 2 + Y0 ^ 2 - 2 * Y0 * Ya + Ya ^ 2))
    A(k, 2 + i * 2 - 1) = -1 * (-(-Ya + Y0) / (X0 ^ 2 - 2 * X0 * Xa + Xa ^ 2 + Y0 ^ 2 - 2 * Y0 * Ya + Ya ^ 2))
    A(k, 2 + i * 2) = -1 * ((-Xa + X0) / (X0 ^ 2 - 2 * X0 * Xa + Xa ^ 2 + Y0 ^ 2 - 2 * Y0 * Ya + Ya ^ 2))
    P(k) = 1 / (InputParam.SDepsazim ^ 2)
    'P(k) = 1
    LinearizedAzim = Atan2((Ya - Y0), (Xa - X0))
    y(k) = obs(i).ObsAzim - LinearizedAzim
    If obs(i).ObsAzim > PI / 2 Then
     Rem Observations is in quadrant 4
     If LinearizedAzim >= -PI / 2 And LinearizedAzim <= PI Then
     Rem Linearized, calculated obs is in quadrants 1,2 or 4
      y(k) = obs(i).ObsAzim - LinearizedAzim
      Else
      Rem Linearized, calculated obs is in quadrant 3
      y(k) = -(PI - obs(i).ObsAzim) - (PI + LinearizedAzim)
     End If
    End If
    
    If obs(i).ObsAzim < -PI / 2 Then
    Rem Observation is in quadrant 3
     If LinearizedAzim >= -PI And LinearizedAzim <= PI / 2 Then
    Rem Linearized, calculated obs is in quadrants 3,2 or 1
      y(k) = obs(i).ObsAzim - LinearizedAzim
     Else
    Rem Linearized, calculated obs is in quadrant 4
      y(k) = (PI - obs(i).ObsAzim) - (PI + LinearizedAzim)
     End If
    End If
   Print #11, k, "1", A(k, 1)
   Print #11, k, "2", A(k, 2)
   Print #11, k, 2 + i * 2 - 1, A(k, 2 + i * 2 - 1)
   Print #11, k, 2 + i * 2, A(k, 2 + i * 2)
   NofNonZeroInA = NofNonZeroInA + 4
   Print #12, y(k)
   Print #13, P(k)
   obs(i).ResidAzim = y(k)
   obs(i).idAzim = k

  End If
  
  If obs(i).ISdist = True Then
    k = k + 1
    A(k, 1) = (-Xa + X0) / (Sqr((Xa - X0) ^ 2 + (Ya - Y0) ^ 2))
    A(k, 2) = (-Ya + Y0) / (Sqr((Xa - X0) ^ 2 + (Ya - Y0) ^ 2))
    A(k, 2 + i * 2 - 1) = -1 * ((-Xa + X0) / (Sqr((Xa - X0) ^ 2 + (Ya - Y0) ^ 2)))
    A(k, 2 + i * 2) = -1 * ((-Ya + Y0) / (Sqr((Xa - X0) ^ 2 + (Ya - Y0) ^ 2)))
    
    
    P(k) = 1 / (InputParam.SDepsdist ^ 2)
    'P(k) = (InputParam.SDepsazim ^ 2) / (InputParam.SDepsdist ^ 2)
'    P(k) = 1
    LinearizedDist = Sqr((Xa - X0) ^ 2 + (Ya - Y0) ^ 2)
    y(k) = obs(i).ObsDist - LinearizedDist
    Print #11, k, "1", A(k, 1)
    Print #11, k, "2", A(k, 2)
    Print #11, k, 2 + i * 2 - 1, A(k, 2 + i * 2 - 1)
    Print #11, k, 2 + i * 2, A(k, 2 + i * 2)
    NofNonZeroInA = NofNonZeroInA + 4
    Print #12, y(k)
    Print #13, P(k)
    obs(i).ResidDist = y(k)
    obs(i).idDist = k
  End If
Next i
 k = sobs(ix).Ndist + sobs(ix).Nazim + 1

For i = 1 To sobs(ix).NPA
  A(k, 2 + i * 2 - 1) = 1
  A(k + 1, 2 + i * 2) = 1
  'P(k) = (InputParam.SDEpsXa ^ 2) / (InputParam.SDepsazim ^ 2)
  'P(k + 1) = (InputParam.SDEpsYa ^ 2) / (InputParam.SDepsazim ^ 2)
  P(k) = 1 / (InputParam.SDEpsXa ^ 2)
  P(k + 1) = 1 / (InputParam.SDEpsYa ^ 2)
  
  y(k) = PA(i).PhotoTruePos.x - PA(i).PhotoPos.x
  y(k + 1) = PA(i).PhotoTruePos.y - PA(i).PhotoPos.y
  Print #11, k, 2 + i * 2 - 1, A(k, 2 + i * 2 - 1)
  Print #11, k + 1, 2 + i * 2, A(k + 1, 2 + i * 2)
  NofNonZeroInA = NofNonZeroInA + 2
  Print #12, y(k)
  Print #12, y(k + 1)
  Print #13, P(k)
  Print #13, P(k + 1)
  k = k + 2
 
 Next i

Dim rows As Long, cols As Long

Open "C:\data\Matlab.txt" For Output As 14
rows = NumOfObservations ' + 2 * sobs(ix).NPA
cols = 2 + 2 * sobs(ix).NPA
df = (sobs(ix).Nazim + sobs(ix).Ndist) - 2

Print #14, rows, cols, NofNonZeroInA, df

Close (14)
Close (11): Close (12): Close (13)

End Sub

Public Sub SolveLSAInMatlab(StopBit As Long, k As Long)

Rem This routine

Rem 1) Calls the MATLAB-LSA function
Rem 2) Reads the following output of Matbal
Rem    - correction vector x
Rem    - sigma-null
Rem    - sigma(X), sigma(Y)
Rem    - test-values w(i) and the critical value

Rem Call to MATLAB Omitted and linear algebra performd in VB, dll has a memory leak
' apu = MYFUNC_MATLABCALLRESECTION(CDbl(1#))

Rem Create AT
Call MatrixTransp(A, AT)
Rem Create weight matrix, PM

Call VectorToDiagMatrix(P, PM)

Rem AT*P
Call MatrixMult(AT, UBound(AT, 1), UBound(AT, 2), PM, UBound(PM, 1), UBound(PM, 2), ATP, UBound(AT, 1), UBound(PM, 2))
Call MatrixMult(ATP, UBound(ATP, 1), UBound(ATP, 2), A, UBound(A, 1), UBound(A, 2), ATPA, UBound(ATP, 1), UBound(A, 2))
Call MatrixMult(ATP, UBound(ATP), UBound(ATP, 2), y, UBound(y), 1, ATPy, UBound(A, 2), 1)
Call MatrixInverse(ATPA, ATPAinv)
Call MatrixMult(ATPAinv, UBound(ATPAinv), UBound(ATPAinv), ATPy, UBound(ATPy, 1), 1, x, UBound(A, 2), 1)



'For i = 1 To UBound(x)
' MsgBox (x(i, 1))
'Next i

ReDim photocorr(1 To 2 * sobs(k).NPA) As Double
 
'Open "c:\data\MatlabOutput.txt" For Input As 1
'Input #1, dx
'Input #1, dy
'For i = 1 To 2 * InputParam.NPA
' Input #1, Photocorr(i)
'Next i

dx = x(1, 1)
dy = x(2, 1)
For i = 1 To 2 * sobs(k).NPA
 photocorr(i) = x(2 + i, 1)
Next i


'Input #1, sigmaNull
'Input #1, sigmaX
'Input #1, sigmaY

ReDim Baarda(1 To UBound(A)) As Double
Dim MaxBaarda As Double
MaxBaarda = 0
'For i = 1 To NumOfObservations
' Input #1, Baarda(i)
' If Abs(Baarda(i)) > MaxBaarda Then
'  MaxBaarda = Abs(Baarda(i))
'  MaxBaardaIndex = i
' End If
'Next i
P0.InitialPos.x = P0.InitialPos.x + dx
P0.InitialPos.y = P0.InitialPos.y + dy
For i = 1 To sobs(k).NPA
 PA(i).PhotoPos.x = PA(i).PhotoPos.x + photocorr(i * 2 - 1)
 PA(i).PhotoPos.y = PA(i).PhotoPos.y + photocorr(i * 2)
Next i
StopBit = CONTINUE
If (Abs(dx) < 0.01 And Abs(dy) < 0.01) Or (Abs(dx) > 100 And Abs(dy) > 100) Then
  
  Rem Compute statistics
  Call VectMatrixMult(y, 1, UBound(y), PM, UBound(PM, 1), UBound(PM, 2), vTPM, 1, UBound(PM, 2))
  Call MatrixMult(vTPM, 1, UBound(PM, 2), y, UBound(y), 1, sigmaN, 1, 1)
  sigmaNull = Sqr(sigmaN(1, 1) / (UBound(A, 1) - UBound(A, 2)))
  
  Call SquareMatrixDiagToVector(ATPAinv, diagQxx)
  sigmaX = Sqr(diagQxx(1)) * sigmaNull
  sigmaY = Sqr(diagQxx(2)) * sigmaNull
  
  Rem Compute matrix Qvv = inv(P) - A*Qxx*AT
  Call MatrixInverse(PM, PMinv)
  Call MatrixMult(A, UBound(A, 1), UBound(A, 2), ATPAinv, UBound(ATPAinv, 1), UBound(ATPAinv, 2), AQxx, UBound(A, 1), UBound(ATPAinv, 2))
  Call MatrixMult(AQxx, UBound(AQxx, 2), UBound(AQxx, 2), AT, UBound(AT, 1), UBound(AT, 2), AQxxAT, UBound(A, 1), UBound(A, 1))
  Call MatrixSum(PMinv, AQxxAT, Qvv)
  
  
  For i = 1 To UBound(y)
   Baarda(i) = Abs(y(i) / (sigmaNull * Qvv(i, i)))
  Next i
  
  StopBit = FINISH
  
 ReDim Qxxx(1 To 2, 1 To 2) As Single
 ReDim dd(1 To 2) As Single
 ReDim vv(1 To 2, 2) As Single
  
  Close (3)
'  Open "c:\Qxxx.txt" For Output As 3
'  For i = 1 To 2
'    For j = 1 To 2
'    Qxxx(i, j) = ATPAinv(i, j) ' * sigmaNull ^ 2
'    Print #3, i, j, Qxxx(i, j)
'   Next j
'  Next i

' Close (3)
 
' apu = MYFUNC_EIG(Qxxx(1, 1), dd(1), vv(1, 1), CLng(2), CLng(2))
  

  
'  Open "c:\data\eigd.txt" For Input As 3
 
'  For i = 1 To UBound(dd)
'   Input #3, dd(i)
'   dd(i) = Sqr(Abs(dd(i))) * sigmaNull
'  Next i
'  Close (3)
  
 ' Open "c:\data\eigV.txt" For Input As 3
 ' For i = 1 To UBound(vv, 1)
 '  For j = 1 To UBound(vv, 2)
 '   Input #3, vv(i, j)
 ' Next j
 ' Next i
 ' Close (3)

  
End If

Close (1)


End Sub
Public Sub PrintOutputForSimu()
Rem This routine prints general info about the simulation with N repetitions
Open InputParam.OutputFilename For Output As 1
Print #1, "Header-section"
Close (1)

End Sub
Public Sub PrintOutputPerIte(k As Long, Nite As Long)
Dim PrintString As String

Open "c:\data\mapdata.txt" For Append As 2

PrintString = PrintString & Format$(sobs(k).Ntree, "0") & ","
PrintString = PrintString & Format$(sobs(k).Sp, "0") & ","
PrintString = PrintString & Format$(P0.InitialPos.x, "0.00") & ","
PrintString = PrintString & Format$(P0.InitialPos.y, "0.00") & ","
PrintString = PrintString & Format$(dd(1), "0.00000") & ","
PrintString = PrintString & Format$(dd(2), "0.00000") & ","
PrintString = PrintString & Format$(vv(1, 1), "0.00000") & ","
PrintString = PrintString & Format$(vv(1, 2), "0.00000") & ","
PrintString = PrintString & Format$(vv(2, 1), "0.00000") & ","
PrintString = PrintString & Format$(vv(2, 2), "0.00000") & ","
For i = 1 To sobs(k).NPA
 PrintString = PrintString & Format$(PA(i).PhotoPos.x, "0.00") & ","
 PrintString = PrintString & Format$(PA(i).PhotoPos.y, "0.00") & ","
Next i
Print #2, PrintString
PrintString = ""
Close (2)


Open InputParam.OutputFilename For Append As 1
PrintString = "Case,NumofIte,Plot-id,Tree-id, Sp, X_ini, Y_ini, X_adj, Y_adj, SigmaNull, SigmaX, SigmaY, Tau, NPA, NumOfObs, "
For i = 1 To sobs(k).NPA
PrintString = PrintString & "Tree, Sp, Obs_X, Obs_Y, X_adj, Y_adj, Res_Azim, Res_Dist, IsDist, BaardaDist, Obs_dist, Is_Azim, Baarda_Azim, Obs_azim,"
Next i
PrintString = PrintString & "TypeOfIni"
Print #1, PrintString
PrintString = ""

PrintString = k & ","
PrintString = PrintString & Nite & ","
PrintString = PrintString & sobs(k).plotNum & ","
PrintString = PrintString & sobs(k).Ntree & ","
PrintString = PrintString & sobs(k).Sp & ","
'PrintString = PrintString & Format$(P0.TruePos.x, "0.00") & ","
'PrintString = PrintString & Format$(P0.TruePos.y, "0.00") & ","
PrintString = PrintString & Format$(P0.InitialWithNoAdjustmentPos.x, "0.00") & ","
PrintString = PrintString & Format$(P0.InitialWithNoAdjustmentPos.y, "0.00") & ","
PrintString = PrintString & Format$(P0.InitialPos.x, "0.00") & ","
PrintString = PrintString & Format$(P0.InitialPos.y, "0.00") & ","
PrintString = PrintString & Format$(sigmaNull, "0.000") & ","
PrintString = PrintString & Format$(sigmaX, "0.00") & ","
PrintString = PrintString & Format$(sigmaY, "0.00") & ","
PrintString = PrintString & Format$(tau(NumOfObservations - 2), "0.0000") & ","
PrintString = PrintString & sobs(k).NPA & ","
PrintString = PrintString & NumOfObservations & ","
For i = 1 To sobs(k).NPA
 PrintString = PrintString & sobs(k).TreeNum(i) & ","
 PrintString = PrintString & sobs(k).TreeSp(i) & ","
 PrintString = PrintString & Format$(PA(i).TruePos.x, "0.00") & ","
 PrintString = PrintString & Format$(PA(i).TruePos.y, "0.00") & ","
 PrintString = PrintString & Format$(PA(i).PhotoPos.x, "0.00") & ","
 PrintString = PrintString & Format$(PA(i).PhotoPos.y, "0.00") & ","
 PrintString = PrintString & Format$(obs(i).ResidAzim, "0.0000") & ","
 PrintString = PrintString & Format$(obs(i).ResidDist, "0.000") & ","
 PrintString = PrintString & obs(i).ISdist & ","
  If obs(i).ISdist = True Then
   PrintString = PrintString & Format$(Baarda(obs(i).idDist), "0.0000") & ","
  Else
   PrintString = PrintString & "-999" & ","
  End If
 PrintString = PrintString & Format$(obs(i).ObsDist, "0.00") & ","
 PrintString = PrintString & obs(i).ISazim & ","
  If obs(i).ISazim = True Then
   PrintString = PrintString & Format$(Baarda(obs(i).idAzim), "0.0000") & ","
  Else
   PrintString = PrintString & "-999" & ","
  End If
 PrintString = PrintString & Format$(obs(i).ObsAzim, "0.0000") & ","
 
 Next i
 PrintString = PrintString & OutputParam.TypeOfInitialApproximationSolution
Print #1, PrintString
PrintString = ""
Close (1)
End Sub

Public Sub DrawLines(Plotpoints As Boolean)
If Plotpoints = True Then
 Form1.Picture1.Cls
 Form1.Picture1.DrawWidth = 2
 Form1.Picture1.Line (10, 200)-(390, 200)
 Form1.Picture1.Line (200, 390)-(200, 10)
 Form1.Picture1.DrawWidth = 1
 For i = 50 To 351 Step 50
  Form1.Picture1.Line (190, i)-(210, i)  ' ticks along y axis
  Form1.Picture1.Print Format$((200 - i) / 100, "0.0")
  Form1.Picture1.Line (i, 190)-(i, 210)   ' ticks along x axis
  Form1.Picture1.Print Format$((200 - i) / 100, "0.0")
 Next i
 Form1.Picture1.DrawWidth = 2
End If
End Sub
Public Sub DrawObs(Plotpoints As Boolean)
If Plotpoints = True And Abs(P0.InitialPos.x) < 10 Then
  Xim = 200 + (P0.InitialPos.x) * 100
  Yim = 200 - (P0.InitialPos.y) * 100
  Form1.Picture1.PSet (Xim, Yim), RGB(255, 0, 255)
  DoEvents
End If

End Sub
Public Sub MatrixInverse(mi() As Double, returnvalue() As Double)

Rem This routine calculates inverse matrix (returnvalue) from matrix (m).


'Build Matrix_A
For n = 1 To UBound(mi, 1)
    For m = 1 To UBound(mi, 2)
        Matrix_A(n, m) = mi(n, m)
    Next m
Next n

'Uses Gauss elimination method in order to calculate the inverse matrix [A]-1
'Method: Puts matrix [A] at the left and the singular matrix [I] at the right:
'[ a11 a12 a13 | 1 0 0 ]
'[ a21 a22 a23 | 0 1 0 ]
'[ a31 a32 a33 | 0 0 1 ]
'Then using line operations, we try to build the singular matrix [I] at the left.
'After we have finished, the inverse matrix [A]-1 (bij) will be at the right:
'[ 1 0 0 | b11 b12 b13 ]
'[ 0 1 0 | b21 b22 b23 ]
'[ 0 0 1 | b31 b32 b33 ]

'On Error GoTo errhandler 'In case the inverse cannot be found (Determinant = 0)

Solution_Problem = False
System_DIM = UBound(mi, 1)
ReDim returnvalue(1 To UBound(mi, 1), 1 To UBound(mi, 2))
'Assign values from matrix [A] at the left
For n = 1 To System_DIM
    For m = 1 To System_DIM
        Operations_Matrix(m, n) = Matrix_A(m, n)
    Next
Next

'Assign values from singular matrix [I] at the right
For n = 1 To System_DIM
    For m = 1 To System_DIM
        If n = m Then
            Operations_Matrix(m, n + System_DIM) = 1
        Else
            Operations_Matrix(m, n + System_DIM) = 0
        End If
    Next
Next

'Build the Singular matrix [I] at the left
For k = 1 To System_DIM
   'Bring a non-zero element first by changes lines if necessary
   If Operations_Matrix(k, k) = 0 Then
      For n = k To System_DIM
        If Operations_Matrix(n, k) <> 0 Then line_1 = n: Exit For 'Finds line_1 with non-zero element
      Next n
      'Change line k with line_1
      For m = k To System_DIM * 2
         temporary_1 = Operations_Matrix(k, m)
         Operations_Matrix(k, m) = Operations_Matrix(line_1, m)
         Operations_Matrix(line_1, m) = temporary_1
      Next m
   End If
   
    elem1 = Operations_Matrix(k, k)
   For n = k To 2 * System_DIM
    Operations_Matrix(k, n) = Operations_Matrix(k, n) / elem1
   Next n
   
   'For other lines, make a zero element by using:
   'Ai1=Aij-A11*(Aij/A11)
   'and change all the line using the same formula for other elements
   For n = 1 To System_DIM
        If n = k And n = MAX_DIM Then Exit For 'Finished
        If n = k And n < MAX_DIM Then n = n + 1 'Do not change that element (already equals to 1), go for next one
      If Operations_Matrix(n, k) <> 0 Then 'if it is zero, stays as it is
         multiplier_1 = Operations_Matrix(n, k) / Operations_Matrix(k, k)
         For m = k To 2 * System_DIM
            Operations_Matrix(n, m) = Operations_Matrix(n, m) - Operations_Matrix(k, m) * multiplier_1
         Next m
      End If
   Next n
Next k

'Assign the right part to the Inverse_Matrix
For n = 1 To System_DIM
    For k = 1 To System_DIM
        Inverse_Matrix(n, k) = Operations_Matrix(n, System_DIM + k)
        returnvalue(n, k) = Inverse_Matrix(n, k)
    Next k
Next n
Exit Sub
errhandler:
MsgBox ("Solution not found!")
End Sub
Public Sub MatrixMult(Ai() As Double, rowsA As Long, colsA As Long, Bi() As Double, rowsB As Long, colsB As Long, AB() As Double, rowsAB As Long, colsAB As Long)

Rem This routine multiplicates matrices A and B and creates matrix AB.

Dim Arows, Acols, Brows, Bcols, ABrows, ABcols As Double
Dim CellSum As Double
ss1 = UBound(Bi, 1)
On Error Resume Next
SS2 = 0
SS2 = UBound(Bi, 2)
If colsA <> rowsB Then
    MsgBox ("The number of A's columns differ from the number of B's rows")
End If


ReDim AB(1 To rowsAB, 1 To colsAB) As Double


Doneselection:


For r = 1 To rowsA
    For c = 1 To colsB
        CellSum = 0
        For i = 1 To colsA
            If colsAB = 1 And SS2 = 0 Then
             CellSum = CellSum + Ai(r, i) * Bi(i)
            Else
             CellSum = CellSum + Ai(r, i) * Bi(i, c)
            End If
        Next i
        AB(r, c) = CellSum
    Next c
Next r


'ReDim Preserve AB(1 To rowsAB, 1 To colsAB) As Double

End Sub
Public Sub VectMatrixMult(Ai() As Double, rowsA As Long, colsA As Long, Bi() As Double, rowsB As Long, colsB As Long, AB() As Double, rowsAB As Long, colsAB As Long)

Rem This routine multiplicates row vector a and matrix B and creates row vector AB.

Dim Arows, Acols, Brows, Bcols, ABrows, ABcols As Double
Dim CellSum As Double
ss1 = UBound(Bi, 1)
On Error Resume Next
SS2 = 0
SS2 = UBound(Bi, 2)
If colsA <> rowsB Then
    MsgBox ("The number of A's columns differ from the number of B's rows")
End If


ReDim AB(1 To rowsAB, 1 To colsAB) As Double


Doneselection:


For r = 1 To rowsA
    For c = 1 To colsB
        CellSum = 0
        For i = 1 To colsA
             CellSum = CellSum + Ai(i) * Bi(i, c)
        Next i
        AB(r, c) = CellSum
    Next c
Next r


'ReDim Preserve AB(1 To rowsAB, 1 To colsAB) As Double


End Sub

Public Sub MatrixSum(Ai() As Double, Bi() As Double, Ci() As Double)
ReDim Ci(1 To UBound(Ai, 1), 1 To UBound(Ai, 2))
For i = 1 To UBound(Ai, 1)
 For j = 1 To UBound(Ai, 2)
  Ci(i, j) = Ai(i, j) + Bi(i, j)
 Next j
Next i

End Sub

Public Sub MatrixTransp(Ai() As Double, ATi() As Double)

Rem This routine transposes matrix A to matrix AT.

Dim Arows, Acols As Double

Arows = UBound(Ai, 1)
Acols = UBound(Ai, 2)

ReDim ATi(1 To Acols, 1 To Arows) As Double
For i = 1 To Arows
    For j = 1 To Acols
        ATi(j, i) = Ai(i, j)
    Next j
Next i

End Sub
Public Sub SquareMatrixDiagToVector(Ai() As Double, Adiag() As Double)

Rem This routine constructs vector (Adiag) from square matrix's (A) diagonal cells.

Dim Adims As Double

If UBound(Ai, 1) <> UBound(Ai, 2) Then
    MsgBox ("Matrix isn't a square matrix")
End If

Adims = UBound(Ai, 1)
ReDim Adiag(1 To Adims)

For i = 1 To Adims
    Adiag(i) = Ai(i, i)
Next i

End Sub
Public Sub VectorToDiagMatrix(v() As Double, Ai() As Double)

Rem This routine constructs diagonal matrix (A) from vector (v)

Dim vLen As Double

vLen = UBound(v, 1)
ReDim Ai(1 To vLen, 1 To vLen)

For i = 1 To vLen
    Ai(i, i) = v(i)
Next i

End Sub
Public Function Atan2(ByVal y As Double, ByVal x As Double) As Double
  Dim theta As Double

  If (Abs(x) < 0.0000001) Then
    If (Abs(y) < 0.0000001) Then
      theta = 0#
    ElseIf (y > 0#) Then
      theta = 1.5707963267949
    Else
      theta = -1.5707963267949
    End If
  Else
    theta = Atn(y / x)
  
    If (x < 0) Then
      If (y >= 0#) Then
        theta = 3.14159265358979 + theta
      Else
        theta = theta - 3.14159265358979
      End If
    End If
  End If
    
  Atan2 = theta
End Function


